import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import javax.swing.*;

public class BusyCursor
{
  public static Object invoke (Component c,
                               Object obj,
                               String meth,
                               Object[] arguments)
  {
     Object result = null;

     Cursor cursor = c.getCursor();
     c.setCursor (new Cursor(Cursor.WAIT_CURSOR));

     try
     {
       Class c = obj.getClass();
       Method m = c.getDeclaredMethod (meth, null);
       m.invoke (obj, arguments);
     }
     catch (Exception e) { }

     c.setCursor (cursor);  // restore it

     return (result);
  }

  public void someSlowMethod() // just for demo
  {
    try { Thread.sleep (5000); }
    catch (InterruptedException e) { }
  }

  public static void main (String[] args)
  {
    final BusyCursor demo = new BusyCursor();

    final JFrame frame = new JFrame ("BusyCursor");
    JButton button = new JButton ("DO STUFF");
    button.addActionListener (new ActionListener() {
      public void actionPerformed (ActionEvent e) {
        BusyCursor.invoke
          (frame, demo, "someSlowMethod", null);
       }
    });
    frame.getContentPane().add (button);
    frame.pack();
    frame.setVisible (true);
  }
}
