public class MyPool extends ObjectPoolAdapter
{
   static MyPool pool;

   private MyPool() { }
   
   public static MyPool getPool()
   { 
      if (pool == null)
         pool = new MyPool();
      return (pool);
   }
   
   public static MyObject getInstance() throws MyException
   {
      try
      {
         return ((MyObject)MyPool.getPool().borrow());
      }
      catch (Exception e)
      {
         throw ((MyException) e);
      }
   }
   
   Object construct() throws Exception
   {
      return (new MyObject());
   }
   
   public static void main (String[] args)
   {
      // sample usage
      MyPool pool = MyPool.getPool();
      MyObject obj = null;
      try
      {
         obj = pool.getInstance();
         // use object
      }
      catch (MyException e)
      {
         // handle exception normally
      }
      finally
      {
         if (obj != null)
            pool.release (obj);
      }
   }
}

