
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;

public class JTextFieldList extends JFrame implements ActionListener
{
    int     dockPosition = 0;
    int     textFieldTotal = 0;
    JButton  dockButton = new JButton("Dock >");
    JButton  addTextFieldButton = new JButton("Add Text Field");
    JButton  removeTextFieldButton = new JButton ("Remove Text Field");
    JPanel   pButtons = new JPanel();
    JPanel  pCenter = new JPanel();
    Vector  v = new Vector();

    public JTextFieldList (String title)
    {
        super(title);

        getContentPane().setLayout(new BorderLayout());

        pButtons.setLayout(new FlowLayout());
        pCenter.setLayout(new FlowLayout());

        pButtons.add(dockButton);
        pButtons.add(addTextFieldButton);
        pButtons.add(removeTextFieldButton);
        dockButton.addActionListener(this);
        addTextFieldButton.addActionListener(this);
        removeTextFieldButton.addActionListener(this);

        addTextField(pCenter);
        addTextField(pCenter);

        getContentPane().add("North", pButtons);
        getContentPane().add("Center", pCenter);

        setSize(600,400);
        setVisible(true);
    }

    private void addTextField (JPanel p)
    {
        JTextField tf = new JTextField("Text: " + textFieldTotal, 30);
        v.addElement(tf);
        p.add(tf);
        textFieldTotal++;
    }

    private void removeTextField (JPanel p)
    {
        if (textFieldTotal > 0)
        {
            textFieldTotal--;
            p.remove((Component)v.elementAt(textFieldTotal));
            v.removeElementAt(textFieldTotal);
        }
    }

    public void actionPerformed (ActionEvent evt)
    {
        Object source = evt.getSource();

        if (source == addTextFieldButton)
        {
            addTextField(pCenter);
            pCenter.invalidate();
            pCenter.validate();
        }
        else if (source == removeTextFieldButton)
        {
            removeTextField(pCenter);
            //pCenter.invalidate();
            //pCenter.validate();
            //pCenter.repaint();
        }
        else if (source == dockButton)
        {
            getContentPane().remove(pButtons);
            switch (dockPosition)
            {
                case 0:
                    getContentPane().add("West", pButtons);
                    break;
                case 1:
                    getContentPane().add("South", pButtons);
                    break;
                case 2:
                    getContentPane().add("East", pButtons);
                    break;
                case 3:
                    getContentPane().add("North", pButtons);
                    break;
            }
            if (dockPosition == 3)
                dockPosition = 0;
            else
                dockPosition++;

            getContentPane().invalidate();
            getContentPane().validate();
        }
    }

    public static void main (String args[])
    {
        new JTextFieldList("JTextFieldList");
    }
}

