
import java.awt.*;
import java.awt.event.*;

public class BasicSearch2 extends Frame implements ActionListener
{
    Label       searchLabel = new Label("Find:");
    TextField   searchTextField = new TextField(20);
    Label       resultsLabel = new Label("Results:");
    List        results = new List();

    Button      searchButton = new Button("Search");
    Button      cancelButton = new Button("Cancel");
    SearchWorker    searchWorker;

    static String[] words = { "ace", "race", "mace", "pace",
                             "chase", "rice", "splice", "mice",
                             "diced", "price", "lime", "dime" };

    public BasicSearch2 (String title)
    {
        super(title);

        searchWorker = new SearchWorker(this);

        Panel searchPanel = new Panel();
        Panel resultsPanel = new Panel();
        Panel buttonPanel = new Panel();

        this.setLayout(new BorderLayout());
        searchPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
        resultsPanel.setLayout(new BorderLayout());
        buttonPanel.setLayout(new FlowLayout(FlowLayout.CENTER));

        searchPanel.add(searchLabel);
        searchPanel.add(searchTextField);

        resultsPanel.add("North", resultsLabel);
        resultsPanel.add("Center", results);

        buttonPanel.add(searchButton);
        buttonPanel.add(cancelButton);

        searchButton.addActionListener(this);
        cancelButton.addActionListener(this);
        cancelButton.setEnabled(false);

        this.add("North", searchPanel);
        this.add("Center", resultsPanel);
        this.add("South", buttonPanel);

        this.setSize(300,300);
        this.setVisible(true);
    }

    public void actionPerformed (ActionEvent evt)
    {
        Object source = evt.getSource();

        if (source == searchButton)
        {
            searchButton.setEnabled(false);
            cancelButton.setEnabled(true);
            results.removeAll();
            searchWorker.doSearch(searchTextField.getText());
        }
        else if (source == cancelButton)
        {
            searchWorker.cancelSearch();
            searchButton.setEnabled(true);
            cancelButton.setEnabled(false);
        }
    }

    public static void main (String args[])
    {
        new BasicSearch2("Basic Search");
    }
}

class SearchWorker extends Thread
{
    BasicSearch2 basicSearch2;
    String       searchText;

    public SearchWorker (BasicSearch2 basicSearch2)
    {
        this.basicSearch2 = basicSearch2;
    }

    public void doSearch (String searchText)
    {
        this.searchText = searchText;
        this.start();
    }

    public void cancelSearch ()
    {
        interrupt();
    }

    public void run ()
    {
        for (int i = 0; i < basicSearch2.words.length; i++)
        {
            try
            {
                if (Thread.interrupted())
                    throw new InterruptedException();

                Thread.sleep(1000);
                if (basicSearch2.words[i].indexOf(searchText) != -1)
                    basicSearch2.results.add(basicSearch2.words[i]);
            }
            catch (InterruptedException e)
            {
                break;
            }
        }

        basicSearch2.searchButton.setEnabled(true);
        basicSearch2.cancelButton.setEnabled(false);
    }
}