
import java.awt.*;
import java.util.*;

public class Item46_5
{
    private static int  listSize;
    private static long elapsedTime;

    public static void main (String args[])
    {
        listSize = Integer.parseInt(args[0]);
        displayLookupList(loadLookupData());
    }

    private static void displayLookupList (int items[])
    {
        Frame f = new Frame("Performance Contest");
        f.setLayout(new BorderLayout());

        Label time = new Label("Time to load " + items.length +
                               " item list: " + elapsedTime + " ms");
        java.awt.List displayList = new java.awt.List();
        for (int i = 0; i < items.length; i++)
            displayList.add("" + items[i]);

        f.add("North", time);
        f.add("Center", displayList);
        f.setSize(400,400);
        f.setVisible(true);
    }

    private static int[] loadLookupData ()
    {
        IntEnumeration preloadedData = getPreloadedData();
        int[] lookupData = new int[10];
        int[] temp = null;
        int   index = 0;
        int   capacity = lookupData.length;

        Date startTime = new Date();
        while (preloadedData.hasMoreElements())
        {
            if (index == capacity)
            {
                temp = lookupData;
                lookupData = new int[lookupData.length * 2];
                capacity = lookupData.length;
                System.arraycopy(temp,0,lookupData,0,temp.length);
            }

            lookupData[index] = preloadedData.nextElement();
            index++;
        }
        // trim array
        temp = lookupData;
        lookupData = new int[index];
        System.arraycopy(temp,0,lookupData,0,lookupData.length);

        Date stopTime = new Date();
        elapsedTime = stopTime.getTime() - startTime.getTime();
        System.out.println("Elapsed time: " + elapsedTime + " ms");
        return (lookupData);
    }

    private static IntEnumeration getPreloadedData ()
    {
        int preloadedData[] = new int[listSize];
        for (int i = 0; i < listSize; i++)
            preloadedData[i] = (i * 100);

        return (new IntEnumeration(preloadedData));
    }
}

class IntEnumeration
{
    int count = -1;
    int elements[];

    public IntEnumeration (int[] elements)
    {
        this.elements = elements;
    }

    public boolean hasMoreElements()
    {
        return (count < (elements.length - 1));
    }

    public int nextElement()
    {
        count++;
        return (elements[count]);
    }
}

